#define _WIN32_WINNT 0x0500

#include <windows.h>

// Standard Window Styles
const char * WinStyleNames[] = {"WS_OVERLAPPED", "WS_POPUP", "WS_CHILD", "WS_MINIMIZE", "WS_VISIBLE", "WS_DISABLED", "WS_CLIPSIBLINGS", "WS_CLIPCHILDREN", "WS_MAXIMIZE", "WS_CAPTION", "WS_BORDER", "WS_DLGFRAME", "WS_VSCROLL", "WS_HSCROLL", "WS_SYSMENU", "WS_THICKFRAME", "WS_GROUP", "WS_TABSTOP", "WS_MINIMIZEBOX", "WS_MAXIMIZEBOX", "WS_OVERLAPPEDWINDOW", "WS_POPUPWINDOW"};
const DWORD WinStyleBits[] = {sizeof(WinStyleNames) / sizeof(char *), (DWORD)WinStyleNames, WS_OVERLAPPED, WS_POPUP, WS_CHILD, WS_MINIMIZE, WS_VISIBLE, WS_DISABLED, WS_CLIPSIBLINGS, WS_CLIPCHILDREN, WS_MAXIMIZE, WS_CAPTION, WS_BORDER, WS_DLGFRAME, WS_VSCROLL, WS_HSCROLL, WS_SYSMENU, WS_THICKFRAME, WS_GROUP, WS_TABSTOP, WS_MINIMIZEBOX, WS_MAXIMIZEBOX, WS_OVERLAPPEDWINDOW, WS_POPUPWINDOW};

const char * ExWinStyleNames[] = {"WS_EX_DLGMODALFRAME", "WS_EX_NOPARENTNOTIFY", "WS_EX_TOPMOST", "WS_EX_ACCEPTFILES", "WS_EX_TRANSPARENT", "WS_EX_MDICHILD", "WS_EX_TOOLWINDOW", "WS_EX_WINDOWEDGE", "WS_EX_CLIENTEDGE", "WS_EX_CONTEXTHELP", "WS_EX_RIGHT", "WS_EX_LEFT", "WS_EX_RTLREADING", "WS_EX_LTRREADING", "WS_EX_LEFTSCROLLBAR", "WS_EX_RIGHTSCROLLBAR", "WS_EX_CONTROLPARENT", "WS_EX_STATICEDGE", "WS_EX_APPWINDOW", "WS_EX_OVERLAPPEDWINDOW", "WS_EX_PALETTEWINDOW", "WS_EX_LAYERED", "WS_EX_NOINHERITLAYOUT", "WS_EX_LAYOUTRTL", "WS_EX_COMPOSITED", "WS_EX_NOACTIVATE"};
const DWORD ExWinStyleBits[] = {sizeof(ExWinStyleNames) / sizeof(char *), (DWORD)ExWinStyleNames, WS_EX_DLGMODALFRAME, WS_EX_NOPARENTNOTIFY, WS_EX_TOPMOST, WS_EX_ACCEPTFILES, WS_EX_TRANSPARENT, WS_EX_MDICHILD, WS_EX_TOOLWINDOW, WS_EX_WINDOWEDGE, WS_EX_CLIENTEDGE, WS_EX_CONTEXTHELP, WS_EX_RIGHT, WS_EX_LEFT, WS_EX_RTLREADING, WS_EX_LTRREADING, WS_EX_LEFTSCROLLBAR, WS_EX_RIGHTSCROLLBAR, WS_EX_CONTROLPARENT, WS_EX_STATICEDGE, WS_EX_APPWINDOW, WS_EX_OVERLAPPEDWINDOW, WS_EX_PALETTEWINDOW, WS_EX_LAYERED, WS_EX_NOINHERITLAYOUT, WS_EX_LAYOUTRTL, WS_EX_COMPOSITED, WS_EX_NOACTIVATE};

// Control Window Styles
const char * ButtonBitNames[] = {"BS_PUSHBUTTON", "BS_DEFPUSHBUTTON", "BS_CHECKBOX", "BS_AUTOCHECKBOX", "BS_RADIOBUTTON", "BS_3STATE", "BS_AUTO3STATE", "BS_GROUPBOX", "BS_USERBUTTON", "BS_AUTORADIOBUTTON", "BS_PUSHBOX", "BS_OWNERDRAW", "BS_TYPEMASK", "BS_LEFTTEXT", "BS_TEXT", "BS_ICON", "BS_BITMAP", "BS_LEFT", "BS_RIGHT", "BS_CENTER", "BS_TOP", "BS_BOTTOM", "BS_VCENTER", "BS_PUSHLIKE", "BS_MULTILINE", "BS_NOTIFY", "BS_FLAT"};
const DWORD ButtonBits[] = {sizeof(ButtonBitNames) / sizeof(char *), (DWORD)ButtonBitNames, BS_PUSHBUTTON, BS_DEFPUSHBUTTON, BS_CHECKBOX, BS_AUTOCHECKBOX, BS_RADIOBUTTON, BS_3STATE, BS_AUTO3STATE, BS_GROUPBOX, BS_USERBUTTON, BS_AUTORADIOBUTTON, BS_PUSHBOX, BS_OWNERDRAW, BS_TYPEMASK, BS_LEFTTEXT, BS_TEXT, BS_ICON, BS_BITMAP, BS_LEFT, BS_RIGHT, BS_CENTER, BS_TOP, BS_BOTTOM, BS_VCENTER, BS_PUSHLIKE, BS_MULTILINE, BS_NOTIFY, BS_FLAT};

const char * EditBitNames[] = {"ES_LEFT", "ES_CENTER", "ES_RIGHT", "ES_MULTILINE", "ES_UPPERCASE", "ES_LOWERCASE", "ES_PASSWORD", "ES_AUTOVSCROLL", "ES_AUTOHSCROLL", "ES_NOHIDESEL", "ES_OEMCONVERT", "ES_READONLY", "ES_WANTRETURN", "ES_NUMBER"};
const DWORD EditBits[] = {sizeof(EditBitNames) / sizeof(char *), (DWORD)EditBitNames, ES_LEFT, ES_CENTER, ES_RIGHT, ES_MULTILINE, ES_UPPERCASE, ES_LOWERCASE, ES_PASSWORD, ES_AUTOVSCROLL, ES_AUTOHSCROLL, ES_NOHIDESEL, ES_OEMCONVERT, ES_READONLY, ES_WANTRETURN, ES_NUMBER};

const char * ComboBitNames[] = {"CBS_SIMPLE", "CBS_DROPDOWN", "CBS_DROPDOWNLIST", "CBS_OWNERDRAWFIXED", "CBS_OWNERDRAWVARIABLE", "CBS_AUTOHSCROLL", "CBS_OEMCONVERT", "CBS_SORT", "CBS_HASSTRINGS", "CBS_NOINTEGRALHEIGHT", "CBS_DISABLENOSCROLL", "CBS_UPPERCASE", "CBS_LOWERCASE"};
const DWORD ComboBits[] = {sizeof(ComboBitNames) / sizeof(char *), (DWORD)ComboBitNames, CBS_SIMPLE, CBS_DROPDOWN, CBS_DROPDOWNLIST, CBS_OWNERDRAWFIXED, CBS_OWNERDRAWVARIABLE, CBS_AUTOHSCROLL, CBS_OEMCONVERT, CBS_SORT, CBS_HASSTRINGS, CBS_NOINTEGRALHEIGHT, CBS_DISABLENOSCROLL, CBS_UPPERCASE, CBS_LOWERCASE};

const char * ListBitNames[] = {"LBS_NOTIFY", "LBS_SORT", "LBS_NOREDRAW", "LBS_MULTIPLESEL", "LBS_OWNERDRAWFIXED", "LBS_OWNERDRAWVARIABLE", "LBS_HASSTRINGS", "LBS_USETABSTOPS", "LBS_NOINTEGRALHEIGHT", "LBS_MULTICOLUMN", "LBS_WANTKEYBOARDINPUT", "LBS_EXTENDEDSEL", "LBS_DISABLENOSCROLL", "LBS_NODATA", "LBS_NOSEL", "LBS_COMBOBOX", "LBS_STANDARD"};
const DWORD ListBits[] = {sizeof(ListBitNames) / sizeof(char *), (DWORD)ListBitNames, LBS_NOTIFY, LBS_SORT, LBS_NOREDRAW, LBS_MULTIPLESEL, LBS_OWNERDRAWFIXED, LBS_OWNERDRAWVARIABLE, LBS_HASSTRINGS, LBS_USETABSTOPS, LBS_NOINTEGRALHEIGHT, LBS_MULTICOLUMN, LBS_WANTKEYBOARDINPUT, LBS_EXTENDEDSEL, LBS_DISABLENOSCROLL, LBS_NODATA, LBS_NOSEL, LBS_COMBOBOX, LBS_STANDARD};

const char * ScrollBitNames[] = {"SBS_HORZ", "SBS_VERT", "SBS_TOPALIGN", "SBS_LEFTALIGN", "SBS_BOTTOMALIGN", "SBS_RIGHTALIGN", "SBS_SIZEBOXTOPLEFTALIGN", "SBS_SIZEBOXBOTTOMRIGHTALIGN", "SBS_SIZEBOX", "SBS_SIZEGRIP"};
const DWORD ScrollBits[] = {sizeof(ScrollBitNames) / sizeof(char *), (DWORD)ScrollBitNames, SBS_HORZ, SBS_VERT, SBS_TOPALIGN, SBS_LEFTALIGN, SBS_BOTTOMALIGN, SBS_RIGHTALIGN, SBS_SIZEBOXTOPLEFTALIGN, SBS_SIZEBOXBOTTOMRIGHTALIGN, SBS_SIZEBOX, SBS_SIZEGRIP};

const char * StaticBitNames[] = {"SS_LEFT", "SS_CENTER", "SS_RIGHT", "SS_ICON", "SS_BLACKRECT", "SS_GRAYRECT", "SS_WHITERECT", "SS_BLACKFRAME", "SS_GRAYFRAME", "SS_WHITEFRAME", "SS_USERITEM", "SS_SIMPLE", "SS_LEFTNOWORDWRAP", "SS_OWNERDRAW", "SS_BITMAP", "SS_ENHMETAFILE", "SS_ETCHEDHORZ", "SS_ETCHEDVERT", "SS_ETCHEDFRAME", "SS_TYPEMASK", "SS_REALSIZECONTROL", "SS_NOPREFIX", "SS_NOTIFY", "SS_CENTERIMAGE", "SS_RIGHTJUST", "SS_REALSIZEIMAGE", "SS_SUNKEN", "SS_EDITCONTROL", "SS_ENDELLIPSIS", "SS_PATHELLIPSIS", "SS_WORDELLIPSIS", "SS_ELLIPSISMASK"};
const DWORD StaticBits[] = {sizeof(StaticBitNames) / sizeof(char *), (DWORD)StaticBitNames, SS_LEFT, SS_CENTER, SS_RIGHT, SS_ICON, SS_BLACKRECT, SS_GRAYRECT, SS_WHITERECT, SS_BLACKFRAME, SS_GRAYFRAME, SS_WHITEFRAME, SS_USERITEM, SS_SIMPLE, SS_LEFTNOWORDWRAP, SS_OWNERDRAW, SS_BITMAP, SS_ENHMETAFILE, SS_ETCHEDHORZ, SS_ETCHEDVERT, SS_ETCHEDFRAME, SS_TYPEMASK, SS_REALSIZECONTROL, SS_NOPREFIX, SS_NOTIFY, SS_CENTERIMAGE, SS_RIGHTJUST, SS_REALSIZEIMAGE, SS_SUNKEN, SS_EDITCONTROL, SS_ENDELLIPSIS, SS_PATHELLIPSIS, SS_WORDELLIPSIS, SS_ELLIPSISMASK};

/* Template
const char * ControlBitNames[] = {};
const DWORD ControlBits[] = {};
*/

const char * ClassNames[] = {"button", "edit", "combobox", "listbox", "scrollbar", "static"};
const DWORD * ClassStyles[] = {ButtonBits, EditBits, ComboBits, ListBits, ScrollBits, StaticBits};
const int ClassCount = sizeof(ClassNames) / sizeof(char *);
